require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MIPS_OCTEON_OCTEONVAR_H_)) {
    eval 'sub _MIPS_OCTEON_OCTEONVAR_H_ () {1;}' unless defined(&_MIPS_OCTEON_OCTEONVAR_H_);
    require 'machine/bus.ph';
    eval 'sub _ASM_PROLOGUE () {"	.set push			\\n" "	.set noreorder			\\n";}' unless defined(&_ASM_PROLOGUE);
    eval 'sub _ASM_PROLOGUE_MIPS64 () { &_ASM_PROLOGUE "	.set mips64			\\n";}' unless defined(&_ASM_PROLOGUE_MIPS64);
    eval 'sub _ASM_PROLOGUE_OCTEON () { &_ASM_PROLOGUE "	.set arch=octeon		\\n";}' unless defined(&_ASM_PROLOGUE_OCTEON);
    eval 'sub _ASM_EPILOGUE () {"	.set pop			\\n";}' unless defined(&_ASM_EPILOGUE);
    unless(defined(&__BITS64_GET)) {
	eval 'sub __BITS64_GET {
	    my($name, $bits) = @_;
    	    eval q(((( &uint64_t)($bits) & $name) >> $name &_SHIFT));
	}' unless defined(&__BITS64_GET);
    }
    unless(defined(&__BITS64_SET)) {
	eval 'sub __BITS64_SET {
	    my($name, $subbits) = @_;
    	    eval q(((( &uint64_t)($subbits) << $name &_SHIFT) & $name));
	}' unless defined(&__BITS64_SET);
    }
    eval 'sub OCTEON_POOL_NO_PKT () {0;}' unless defined(&OCTEON_POOL_NO_PKT);
    eval 'sub OCTEON_POOL_NO_WQE () {1;}' unless defined(&OCTEON_POOL_NO_WQE);
    eval 'sub OCTEON_POOL_NO_CMD () {2;}' unless defined(&OCTEON_POOL_NO_CMD);
    eval 'sub OCTEON_POOL_NO_SG () {3;}' unless defined(&OCTEON_POOL_NO_SG);
    eval 'sub OCTEON_POOL_NO_XXX_4 () {4;}' unless defined(&OCTEON_POOL_NO_XXX_4);
    eval 'sub OCTEON_POOL_NO_XXX_5 () {5;}' unless defined(&OCTEON_POOL_NO_XXX_5);
    eval 'sub OCTEON_POOL_NO_XXX_6 () {6;}' unless defined(&OCTEON_POOL_NO_XXX_6);
    eval 'sub OCTEON_POOL_NO_DUMP () {7;}' unless defined(&OCTEON_POOL_NO_DUMP);
    eval 'sub OCTEON_POOL_SIZE_PKT () {2048;}' unless defined(&OCTEON_POOL_SIZE_PKT);
    eval 'sub OCTEON_POOL_SIZE_WQE () {128;}' unless defined(&OCTEON_POOL_SIZE_WQE);
    eval 'sub OCTEON_POOL_SIZE_CMD () {1024;}' unless defined(&OCTEON_POOL_SIZE_CMD);
    eval 'sub OCTEON_POOL_SIZE_SG () {512;}' unless defined(&OCTEON_POOL_SIZE_SG);
    eval 'sub OCTEON_POOL_SIZE_XXX_4 () {0;}' unless defined(&OCTEON_POOL_SIZE_XXX_4);
    eval 'sub OCTEON_POOL_SIZE_XXX_5 () {0;}' unless defined(&OCTEON_POOL_SIZE_XXX_5);
    eval 'sub OCTEON_POOL_SIZE_XXX_6 () {0;}' unless defined(&OCTEON_POOL_SIZE_XXX_6);
    eval 'sub OCTEON_POOL_SIZE_XXX_7 () {0;}' unless defined(&OCTEON_POOL_SIZE_XXX_7);
    eval 'sub OCTEON_POOL_NELEMS_PKT () {4096;}' unless defined(&OCTEON_POOL_NELEMS_PKT);
    eval 'sub OCTEON_POOL_NELEMS_WQE () {4096;}' unless defined(&OCTEON_POOL_NELEMS_WQE);
    eval 'sub OCTEON_POOL_NELEMS_CMD () {32;}' unless defined(&OCTEON_POOL_NELEMS_CMD);
    eval 'sub OCTEON_POOL_NELEMS_SG () {1024;}' unless defined(&OCTEON_POOL_NELEMS_SG);
    eval 'sub OCTEON_POOL_NELEMS_XXX_4 () {0;}' unless defined(&OCTEON_POOL_NELEMS_XXX_4);
    eval 'sub OCTEON_POOL_NELEMS_XXX_5 () {0;}' unless defined(&OCTEON_POOL_NELEMS_XXX_5);
    eval 'sub OCTEON_POOL_NELEMS_XXX_6 () {0;}' unless defined(&OCTEON_POOL_NELEMS_XXX_6);
    eval 'sub OCTEON_POOL_NELEMS_XXX_7 () {0;}' unless defined(&OCTEON_POOL_NELEMS_XXX_7);
    eval 'sub OCTEON_CVMSEG_OFFSET {
        my($entry) = @_;
	    eval q( &offsetof(\'struct octeon_cvmseg_map\', $entry));
    }' unless defined(&OCTEON_CVMSEG_OFFSET);
    eval 'sub OCTEON_CVMSEG_ETHER_OFFSET {
        my($n, $entry) = @_;
	    eval q(( &offsetof(\'struct octeon_cvmseg_map\',  &csm_ether) + $sizeof{\'struct octeon_cvmseg_ether_map\'} * ($n) +  &offsetof(\'struct octeon_cvmseg_ether_map\', $entry)));
    }' unless defined(&OCTEON_CVMSEG_ETHER_OFFSET);
    eval 'sub OCTEON_POW_QOS_PIP () {0;}' unless defined(&OCTEON_POW_QOS_PIP);
    eval 'sub OCTEON_POW_QOS_CORE1 () {1;}' unless defined(&OCTEON_POW_QOS_CORE1);
    eval 'sub OCTEON_POW_QOS_XXX_2 () {2;}' unless defined(&OCTEON_POW_QOS_XXX_2);
    eval 'sub OCTEON_POW_QOS_XXX_3 () {3;}' unless defined(&OCTEON_POW_QOS_XXX_3);
    eval 'sub OCTEON_POW_QOS_XXX_4 () {4;}' unless defined(&OCTEON_POW_QOS_XXX_4);
    eval 'sub OCTEON_POW_QOS_XXX_5 () {5;}' unless defined(&OCTEON_POW_QOS_XXX_5);
    eval 'sub OCTEON_POW_QOS_XXX_6 () {6;}' unless defined(&OCTEON_POW_QOS_XXX_6);
    eval 'sub OCTEON_POW_QOS_XXX_7 () {7;}' unless defined(&OCTEON_POW_QOS_XXX_7);
    eval 'sub OCTEON_POW_GROUP_PIP () {0;}' unless defined(&OCTEON_POW_GROUP_PIP);
    eval 'sub OCTEON_POW_GROUP_XXX_1 () {1;}' unless defined(&OCTEON_POW_GROUP_XXX_1);
    eval 'sub OCTEON_POW_GROUP_XXX_2 () {2;}' unless defined(&OCTEON_POW_GROUP_XXX_2);
    eval 'sub OCTEON_POW_GROUP_XXX_3 () {3;}' unless defined(&OCTEON_POW_GROUP_XXX_3);
    eval 'sub OCTEON_POW_GROUP_XXX_4 () {4;}' unless defined(&OCTEON_POW_GROUP_XXX_4);
    eval 'sub OCTEON_POW_GROUP_XXX_5 () {5;}' unless defined(&OCTEON_POW_GROUP_XXX_5);
    eval 'sub OCTEON_POW_GROUP_XXX_6 () {6;}' unless defined(&OCTEON_POW_GROUP_XXX_6);
    eval 'sub OCTEON_POW_GROUP_CORE1_SEND () {7;}' unless defined(&OCTEON_POW_GROUP_CORE1_SEND);
    eval 'sub OCTEON_POW_GROUP_CORE1_TASK_0 () {8;}' unless defined(&OCTEON_POW_GROUP_CORE1_TASK_0);
    eval 'sub OCTEON_POW_GROUP_CORE1_TASK_1 () {9;}' unless defined(&OCTEON_POW_GROUP_CORE1_TASK_1);
    eval 'sub OCTEON_POW_GROUP_CORE1_TASK_2 () {10;}' unless defined(&OCTEON_POW_GROUP_CORE1_TASK_2);
    eval 'sub OCTEON_POW_GROUP_CORE1_TASK_3 () {11;}' unless defined(&OCTEON_POW_GROUP_CORE1_TASK_3);
    eval 'sub OCTEON_POW_GROUP_CORE1_TASK_4 () {12;}' unless defined(&OCTEON_POW_GROUP_CORE1_TASK_4);
    eval 'sub OCTEON_POW_GROUP_CORE1_TASK_5 () {13;}' unless defined(&OCTEON_POW_GROUP_CORE1_TASK_5);
    eval 'sub OCTEON_POW_GROUP_CORE1_TASK_6 () {14;}' unless defined(&OCTEON_POW_GROUP_CORE1_TASK_6);
    eval 'sub OCTEON_POW_GROUP_CORE1_TASK_7 () {15;}' unless defined(&OCTEON_POW_GROUP_CORE1_TASK_7);
    eval 'sub BOARD_TYPE_SIM () {1;}' unless defined(&BOARD_TYPE_SIM);
    eval 'sub BOARD_TYPE_UBIQUITI_E100 () {20002;}' unless defined(&BOARD_TYPE_UBIQUITI_E100);
    eval 'sub BOARD_TYPE_UBIQUITI_E200 () {20003;}' unless defined(&BOARD_TYPE_UBIQUITI_E200);
    if(defined(&_KERNEL) || defined(&_STANDALONE)) {
	eval 'sub OCTEON_ARGV_MAX () {64;}' unless defined(&OCTEON_ARGV_MAX);
	eval 'sub OCTEON_MAXCPUS () {4;}' unless defined(&OCTEON_MAXCPUS);
	if(defined(&_KERNEL)) {
	    eval 'sub BOOTINFO_CFG_FLAG_PCI_HOST () {(1 << 0);}' unless defined(&BOOTINFO_CFG_FLAG_PCI_HOST);
	    eval 'sub BOOTINFO_CFG_FLAG_PCI_TARGET () {(1 << 1);}' unless defined(&BOOTINFO_CFG_FLAG_PCI_TARGET);
	    eval 'sub BOOTINFO_CFG_FLAG_DEBUG () {(1 << 2);}' unless defined(&BOOTINFO_CFG_FLAG_DEBUG);
	    eval 'sub BOOTINFO_CFG_FLAG_NO_MAGIC () {(1 << 3);}' unless defined(&BOOTINFO_CFG_FLAG_NO_MAGIC);
	}
    }
    eval 'sub MIO_BOOT_BIST_STAT () {0x11800000000f8;}' unless defined(&MIO_BOOT_BIST_STAT);
}
1;
